package algebra

object Monoids {
  def intAddition: Monoid[Int] = new Monoid[Int] {
    def zero = ???
    def op(a: Int, b: Int): Int = ???
  }

  def intMultiplication: Monoid[Int] = ???

  def booleanOr: Monoid[Boolean] = ???

  def booleanAnd: Monoid[Boolean] = ???

  def optionMonoid[A]: Monoid[Option[A]] = ???

  def endoMonoid[A]: Monoid[A => A] = ???

  def foldMap[A, B](as: List[A], m: Monoid[B])(f: A => B): B = ???

  def foldMapBalanced[A, B](as: IndexedSeq[A], m: Monoid[B])(f: A => B): B = ???

  def mapMergeMonoid[K,V](V: Monoid[V]): Monoid[Map[K, V]] =
    new Monoid[Map[K, V]] {
      def zero = Map[K,V]()
      def op(a: Map[K, V], b: Map[K, V]) =
        (a.keySet ++ b.keySet).foldLeft(zero) { (acc,k) =>
          acc + (k ->
            V.op(a.getOrElse(k, V.zero), b.getOrElse(k, V.zero)))
        }
    }

  def bag[A](as: IndexedSeq[A]): Map[A, Int] = ???

}
