package datastructures

sealed trait List[+A] {
  def head = this match {
    case Nil => sys.error("head of empty list")
    case Cons(a, _) => a
  }

  def tail: List[A] = ???

  def init: List[A] = ???

  def setHead[AA >: A](head: AA): List[AA] = ???

  def foldLeft[B](z: B)(f: (B, A) => B): B = ???
}
case object Nil extends List[Nothing]
case class Cons[+A](elem: A, rest: List[A]) extends List[A]

object List {
  def apply[A](as: A*): List[A] =
    if (as.isEmpty) Nil
    else Cons(as.head, apply(as.tail: _*))
}
