package errors

sealed trait Option[+A] {
  def map[B](f: A => B): Option[B] = ???

  def getOrElse[B >: A](default: => B): B = ???

  def flatMap[B](f: A => Option[B]): Option[B] = ???

  def filter[B](f: A => Boolean): Option[A] = ???
}

final case class Some[+A](get: A) extends Option[A]
case object None extends Option[Nothing]

object Option {
  def sequence[A](list: List[Option[A]]): Option[List[A]] = ???
}
