package typeclasses

import scala.language.higherKinds

object FunctorOption {
  trait Functor[F[_]] {
    def map[A, B](fa: F[A])(f: A => B): F[B]
  }

  //try to write the signature yourself instead of using the IDEs auto-implement
  //uncomment and implement:

  //implicit val optionFunctor: Functor[Option] = new Functor[Option] {
  //}
}
